C                     main.f
C
C
C  ********************************************************************
C  *This file is a main progam for calculation of the E1 strength     *
C  *functions versus gamma-energy Eg for a given nucleus at fixed     * 
C  *excitation energy. The code also creates the auxiliary files      *
C  *which are used to create output file "rsf_E.dat" and              *
C  * .dat files for plotting results with the gnuplot package.        *
C  ********************************************************************
C
      IMPLICIT NONE
      DOUBLE PRECISION  GAMMA_STRENGTH, znucleus, anucleus, eexcit,
     &                  egamma, egmin, egmax, u, deltaegamma,
     &                  amlo1, amlo2, amlo3, eglo, gfl, slo, BC,
     &                  FACtor, AKS0, DEG, alevel, backshift, DMEf
      DOUBLE PRECISION  TEMPERATURE, eexcitf, temperf
      INTEGER keydens, KEYfbc, keyfun, KEYset, keyshape,
     &        la, lz, keyexp, ieg, negamma
c      INTEGER keytest
      COMMON /INPUTKEY/ KEYset, KEYfbc
      COMMON /INPUTPAR/ FACtor, BC, AKS0, DEG, DMEf
      CHARACTER*172 line1/
     &'plot "exp__E.dat" u 1:2:3:4 w e,"mlo1_E.dat" u 1:2 w l,"mlo2_E.da
     &t" u 1:2 w l,"mlo3_E.dat" u 1:2 w l,"eglo_E.dat" u 1:2 w l,"gfl__E
     &.dat" u 1:2 w l, "slo__E.dat" u 1:2 w l  '/
      CHARACTER*172 line2/
     &'plot "mlo1_E.dat" u 1:2 w l,"mlo2_E.dat" u 1:2 w l,"mlo3_E.dat" u
     & 1:2 w l,"eglo_E.dat" u 1:2 w l, "gfl__E.dat" u 1:2 w l,
     & "slo__E.dat" u 1:2 w l                  '/
      CHARACTER line3*12/'set xrange ['/,line5*1/':'/,line4*1/']'/
      OPEN (91,file='mlo1_E.dat')
      OPEN (92,file='mlo2_E.dat')
      OPEN (93,file='mlo3_E.dat')
      OPEN (94,file='eglo_E.dat')
      OPEN (95,file='slo__E.dat')
      OPEN (96,file='rsf_E.dat')
      OPEN (97,file='gnuplot.ini')
      OPEN (98,file='gfl__E.dat')
      WRITE(*,8001)
      WRITE(*,3030)
      READ(*,*)la
      WRITE(*,3029)
      READ(*,*)lz
      anucleus=la
      znucleus=lz
      REWIND 97
      READ(97,560)
C
C        *************************************************************
C        * Set 'keyfun' to specify the radiative process type:       *
C        *                                                           *
C        *  keyfun =1 -->  Gamma-decay                               *
C        *  keyfun =2 -->  Photoabsorption                           *
C        *************************************************************
C
      keyfun=1
C      keyfun=2
      IF(keyfun.eq.1) THEN
        u=7.817
        eexcit=u
        egmin=.1e-3
        egmax=eexcit
        ELSE
C        egmin=.1e-3
        egmin=5.
        egmax=25.
        eexcit=1.e-6
      ENDIF
c     write(*,5011)
c     read(*,*)keyexp
      keyexp = 2
      negamma=199
      deltaegamma=(egmax-egmin)/negamma
      IF(ABS(egmin-egmax).le.0.1e-04) negamma=0
C
      CALL GDRGFLDATA(znucleus, anucleus)
      CALL DENSITYDATA(znucleus, anucleus, alevel, backshift)
C
      DO 5010 ieg=1,negamma+1
      egamma=egmin+(ieg-1)*deltaegamma
C
      IF(keyfun.EQ.1)THEN
         eexcitf = eexcit - egamma
         temperf = TEMPERATURE(eexcitf, 
     &                         alevel, backshift, keydens)
      ELSE
         eexcitf = eexcit
         temperf = TEMPERATURE(eexcitf, 
     &                         alevel, backshift, keydens)
      ENDIF
C
      keyshape=1
      amlo1= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
      keyshape=2
      amlo2= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
      keyshape=3
      amlo3= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
      keyshape=4
      eglo= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
      keyshape=5
      gfl= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
      keyshape=6
      slo= GAMMA_STRENGTH(znucleus, anucleus, eexcitf,
     &                      temperf, egamma, keyshape)
C     
      IF(ieg.eq.1) WRITE(96,3209) la, lz, u, keyfun, keydens, KEYset, 
     &  FACtor, AKS0, DEG
      WRITE(91,3302)egamma,amlo1
      WRITE(92,3302)egamma,amlo2
      WRITE(93,3302)egamma,amlo3
      WRITE(94,3302)egamma,eglo
      WRITE(95,3302)egamma,slo
      WRITE(98,3302)egamma,gfl
      WRITE(96,3302)egamma,amlo1,amlo2,amlo3,eglo,gfl,slo
5010  CONTINUE
      WRITE(97,1558)line3,egmin,line5,egmax,line4
      IF(keyexp.eq.1) THEN
      WRITE(97,558)line1
      ELSE
      WRITE(97,558)line2
      ENDIF
      STOP
558   FORMAT(a172)
560   FORMAT(////////// ////////// //////)
1558  FORMAT(a12,g12.5,a1,g12.5,a1)
3029  FORMAT(10x,' ***************************************'/
     & 10x,' *                                     *'/
     & 10x,' *  Specify  charge Z of nuclide       *'/
     & 10x,' *                                     *'/
     & 10x,' ***************************************'/)
3030  FORMAT(10x,' ***************************************'/
     & 10x,' *                                     *'/
     & 10x,' * Specify  mass number A of nuclide   *'/
     & 10x,' *                                     *'/
     & 10x,' ***************************************'/)
3209  FORMAT('#','  A = ',I3,3X,'  Z = ',I3,3X,' U = ', E12.5 /'#'/
     & '#','  keyfun =',i2,'  keydens =',i2,'  KEYset =',i2 /'#'/
     & '#','  FACtor = ',f5.2,'  AKS0 = ',f5.2,'  DEG = ',f5.2 /'#'/
     & '#','   Egamma      MLO1         MLO2        ',
     & ' MLO3         EGLO       GFL         SLO'/'#')
3302  FORMAT(7g12.5)
5011  format(10x,41('*')/10x,'*',39x,'*'/
     & 10x,'* Set key to plot of  experimental      *'/
     & 10x,'* data from "exp__E.dat"  file:         *'/
     & 10x,'* 1 - should be plotted                 *'/
     & 10x,'* 2 - no                                *'/
     & 10x,'*',39x,'*'/10x,41('*'))
8001  FORMAT(11x,52('*')/
     & 10x,' *',50x,'*'/
     & 10x,' *   The calculations of the E1 gamma-decay         *'/
     & 10x,' *   and photoabsorption  strength functions        *'/
     & 10x,' *   at given A, Z  and  excitation energy U        *'/
     & 10x,' *                                                  *'/
     & 10x,' ****************************************************'/)
      END

